/*
 *  BCCPM.h
 *  
 *  Created by Zhichao Lian on Apr/10/2013.
 *  Copyright 2013 Yale University. All rights reserved.
 *
 */


#ifndef _BCCPM_H_
#define _BCCPM_H_

#include "BCCPMBlock.h"


class BCCPM
{
	HyperParSingle hyper_par_single;
	HyperParGroup hyper_par_group;
	
	int thin;
	long thinned_size;
	
	long num_iter_1;
	long burn_in;
	
	gsl_matrix * data;
	long num_sample;
	int num_pos;
	double change_point_prior;
	
	vector< int > init_block_lengths;
	vector< vector< BCCPMBlock > > samples;
	vector< double > traces;
	vector <double> posts;
	vector< vector< int > > block_labels;
	vector< BCCPMBlock > blocks;
	
	int propose_divide( double & new_post, vector< BCCPMBlock> & new_blocks, gsl_rng * rng );
	int propose_combine( double & new_post, vector< BCCPMBlock > & new_blocks, gsl_rng * rng );
	int propose_shift( double & new_post, vector< BCCPMBlock > & new_blocks, gsl_rng * rng );
	
	int convert_to_block_labels();
	int CaluPost_CP();
public:
	int set_change_point_prior( double change_point_prior );
	int set_thin( int thin );
	int set_burn_in( long burn_in );
	int load_data( long num_sample, long num_pos, string data_file, string par_file,string init_block_file  );
	int output_results( string trace_file, string block_label_file, string post_file, int thin );
	int metro_hast_run();
	double validate_blocks( vector< int > & block_labels, long nIter );
	int get_num_pos();
	long get_num_sample();
	int set_num_iter( long num_iter_1);
	
	BCCPM();
	~BCCPM();
	
};


#endif
