/*
 *  BCCPMBlock.h
 *  
 *  Created by Zhichao Lian on Apr/10/2013.
 *  Copyright 2013 Yale University. All rights reserved.
 *
 */

#ifndef _BCCPMBLOCK_H_
#define _BCCPMBLOCK_H_

#include "CommonHead.h"

using namespace std;



class BCCPMBlock
{
	HyperParSingle hyper_par_single;
	HyperParGroup hyper_par_group;
	
	gsl_matrix_view block_data;
	long start;
	long num_sample;
	long num_pos;
	

	double current_post;
	
	int calc_group_lik( gsl_matrix * group_data, double & likelihood );
	int calc_single_lik( gsl_vector * single_data, double & likelihood );
	
	
public:
	int set_data( long start, long num_sample, gsl_matrix * source );
	double get_current_post();
	int calc_post();
	
	long get_num_sample();
	long get_start();
	
	BCCPMBlock( int num_pos, HyperParGroup & hyper_par_group, HyperParSingle & hyper_par_single );
	~BCCPMBlock();
};

#endif